#include <bits/stdc++.h>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i < (b); i++)
#define RFOR(i, a, b) for(int i = (a) - 1; i >= (b); i--)
#define SZ(a) int(a.size())
#define ALL(a) a.begin(), a.end()
#define PB push_back
#define MP make_pair
#define F first
#define S second

typedef long long LL;
typedef vector<int> VI;
typedef pair<int, int> PII;
typedef double db;

const int N = 74;
const int INF = 1e9 + 47;

int r, c;
string s[N];
string t[N];
int d[N][N];
PII from[N][N];
vector<VI> ans;


void move(int x1, int y1, int x2, int y2)
{
	assert(s[x1][y1] == '*');
	assert(s[x2][y2] == '.');
	ans.PB({x1 + 1, y1 + 1, x2 + 1, y2 + 1});
	s[x1][y1] = '.';
	s[x2][y2] = '*';
}

PII inter()
{
	FOR (i, 0, r)
	{
		FOR (j, 0, c)
		{
			if (s[i][j] == t[i][j] && s[i][j] == '*')
				return {i, j};
		}
	}
	return {-1, -1};
}

vector<PII> dir = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};

bool ok(int x, int y)
{
	return 0 <= x && x < r && 0 <= y && y < c;
}

void solve(int x, int y)
{
	FOR (i, 0, r) FOR (j, 0, c)
	{
		d[i][j] = INF;
		from[i][j] = {-1, -1};
	}
	d[x][y] = 0;
	queue<PII> q;
	for (auto ch : {'*', '.'})
	{
		q.push({x, y});
		while(!q.empty())
		{
			auto [i, j] = q.front();
			q.pop();
			for (auto [dx, dy] : dir)
			{
				int nx = i + dx;
				int ny = j + dy;
				if (ok(nx, ny) && d[nx][ny] > d[i][j] && s[nx][ny] == ch)
				{
					d[nx][ny] = d[i][j] + 1;
					from[nx][ny] = {i, j};
					q.push({nx, ny});
				}
			}
		}
	}
	vector<pair<int, PII>> st;
	vector<pair<int, PII>> en;
	FOR (i, 0, r)
	{
		FOR (j, 0, c)
		{
			if (s[i][j] == '*' && t[i][j] == '.')
				st.PB({d[i][j], {i, j}});
			if (s[i][j] == '.' && t[i][j] == '*')
				en.PB({d[i][j], {i, j}});
		}
	}
	assert(SZ(st) == SZ(en));
	sort(ALL(st), greater());
	sort(ALL(en));
	FOR (i, 0, SZ(st))
	{
		move(st[i].S.F, st[i].S.S, en[i].S.F, en[i].S.S);
	}
}

bool check(int x, int y)
{
	FOR (i, 0, r) FOR (j, 0, c)
	{
		d[i][j] = INF;
		from[i][j] = {-1, -1};
	}
	d[x][y] = 0;
	queue<PII> q;
	for (auto ch : {'*', '.'})
	{
		q.push({x, y});
		while(!q.empty())
		{
			auto [i, j] = q.front();
			q.pop();
			for (auto [dx, dy] : dir)
			{
				int nx = i + dx;
				int ny = j + dy;
				if (ok(nx, ny) && d[nx][ny] > d[i][j] && s[nx][ny] == ch)
				{
					d[nx][ny] = d[i][j] + 1;
					from[nx][ny] = {i, j};
					q.push({nx, ny});
				}
			}
		}
	}
	int dis = -1;
	PII fc;
	FOR (i, 0, r)
	{
		FOR (j, 0, c)
		{
			if (d[i][j] == INF && t[i][j] == '*')
				return false;
			if (t[i][j] == '*' && (dis == -1 || dis > d[i][j]))
			{
				dis = d[i][j];
				fc = {i, j};
			}
		}
	}
	vector<PII> path;
	int x2 = fc.F, y2 = fc.S;
	while (x2 != x && y2 != y)
	{
		path.PB({x2, y2});
		auto par = from[x2][y2];
		x2 = par.F;
		y2 = par.S;
	}
	reverse(ALL(path));
	vector<PII> ameba;
	FOR (i, 0, r)
	{
		FOR (j, 0, c)
		{
			if (s[i][j] == '*')
				ameba.PB({i, j});
		}
	}
	sort(ALL(ameba), [&](PII& a, PII& b)
	{
		return d[a.F][a.S] > d[b.F][b.S];
	});
	int ptr = 0;
	FOR (i, 0, SZ(path))
	{
		move(ameba[ptr].F, ameba[ptr].S, path[i].F, path[i].S);
		ptr++;
		ptr %= SZ(ameba);
	}
	return true;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> r >> c;
	FOR (i, 0, r)
		cin >> s[i];
	FOR (i, 0, r)
		cin >> t[i];
	auto p = inter();
	if (p.F != -1)
		solve(p.F, p.S);
	else
	{
		FOR (cx, 0, r)
		{
			FOR (cy, 0, r)
			{
				if (s[cx][cy] == '*')
				{
					if (check(cx, cy))
					{
						p = inter();
						solve(p.F, p.S);
						break;
					}
				}
			}
			if (!ans.empty())
				break;
		}
	}
	if (ans.empty())
	{
		cout << "NO\n";
	}
	else
	{
		cout << "YES\n";
		cout << SZ(ans) << '\n';
		FOR (i, 0, SZ(ans))
		{
			FOR (j, 0, SZ(ans[i]))
			{
				if (j)
					cout << ' ';
				cout << ans[i][j];
			}
			cout << '\n';
		}
	}
	
	
	
	return 0;
}
